﻿// Generated by Tekla.Technology.Akit.ScriptBuilder
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Globalization;
using System.Linq;
// Tekla Structures namespaces 
using Tekla.Structures;
using Tekla.Structures.Model;
using Tekla.Structures.Geometry3d;
using Tekla.Structures.Solid;
using Tekla.Structures.Model.UI;
using Tekla.Structures.Plugins;
using Tekla.Structures.Dialog.UIControls;
using Tekla.Structures.Dialog;
using Tekla.Structures.Catalogs;
using Tekla.Structures.Datatype;
using TSM = Tekla.Structures.Model;
using TSP = Tekla.Structures.Plugins;
using T3D = Tekla.Structures.Geometry3d;
using TSC = Tekla.Structures.Catalogs;
using TSCUI = Tekla.Structures.Dialog.UIControls;
using TSMUI = Tekla.Structures.Model.UI;
using TSD = Tekla.Structures.Dialog;
using Tekla.Structures.Model.Operations;
// Additional namespace references 
using System.Collections;
using System.IO;

namespace NumberingDrawingHistory
{
    public partial class NumberingDrawingHistory : Form
    {
        public NumberingDrawingHistory()
        {
            InitializeComponent();
            foreach (EncodingInfo ei in Encoding.GetEncodings())
            {
                encodebox.Items.Add(ei.Name);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            #region initial
            dgvpart.Rows.Clear();
            dgvassembly.Rows.Clear();
            dgvpart.Columns.Clear();
            dgvassembly.Columns.Clear();
            string encodetxt = "";
            int selectind = 0;
            if (numdwghist.SelectedIndex == 0)
            {
                selectind = 0;
            }
            if (numdwghist.SelectedIndex == 1)
            {
                selectind = 1;
            }
            Model model1 = new Model();
            if (encodebox.Text != "")
            {
                encodetxt = encodebox.Text;
            }
            else
            {
                encodetxt = "us-ascii";
            }

            #endregion

            #region FindPath
            ModelInfo info1 = model1.GetInfo();
            string mpath = info1.ModelPath;
            string filepath = Path.Combine(mpath, "numberinghistory.txt");
            string filepath2 = Path.Combine(mpath, "drawing_history.log");
            #endregion

            #region dgvsettings
            DataGridViewColumn newcol11 = new DataGridViewColumn();
            DataGridViewCell newcell11 = new DataGridViewTextBoxCell();
            newcol11.CellTemplate = newcell11;
            newcol11.AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dgvpart.Columns.Add(newcol11);
            DataGridViewColumn newcol21 = new DataGridViewColumn();
            DataGridViewCell newcell21 = new DataGridViewTextBoxCell();
            newcol21.CellTemplate = newcell21;
            newcol21.AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dgvassembly.Columns.Add(newcol21);
            #endregion

            #region variables
            string partinfo = "";
            string ainfo = "";
            string data = "*** Numbering";
            #endregion

            #region NumberingHistory
            if (selectind == 0)
            {
                #region main
                foreach (var ModelObject in new TSMUI.ModelObjectSelector().GetSelectedObjects())
                {
                    Part part1 = ModelObject as Part;
                    string pguid = part1.Identifier.GUID.ToString();
                    string fpguid = "ID" + pguid.ToUpper();
                    Assembly assembly1 = part1.GetAssembly();
                    string aguid = assembly1.Identifier.GUID.ToString();
                    string faguid = "ID" + aguid.ToUpper();

                    if (File.Exists(filepath) == true)
                    {
                        StreamReader reader = new StreamReader(filepath, Encoding.GetEncoding(encodetxt));
                        using (reader)
                        {
                            int linenum = 0;
                            string line = reader.ReadLine();
                            while (line != null)
                            {
                                linenum++;
                                if (line.ToString().Contains(fpguid) || line.ToString().Contains(data))
                                {
                                    partinfo = line.ToString();
                                    object[] rowdata1 = new object[] { partinfo };
                                    dgvpart.Rows.Add(rowdata1);
                                }
                                if (line.ToString().Contains(faguid) || line.ToString().Contains(data))
                                {
                                    ainfo = line.ToString();
                                    object[] rowdata2 = new object[] { ainfo };
                                    dgvassembly.Rows.Add(rowdata2);
                                }
                                line = reader.ReadLine();
                            }
                        }
                    }
                }
                #endregion

                #region PartNumFill
                int dgvrc = dgvpart.Rows.Count;
                List<int> listnum = new List<int>();
                List<int> listpart = new List<int>();
                List<int> listall = new List<int>();
                for (int i = 0; i < dgvrc - 1; i++)
                {
                    string cellv1 = dgvpart.Rows[i].Cells[0].Value.ToString();
                    if (cellv1.Contains("Part"))
                    {
                        listnum.Add(i - 1);
                        listpart.Add(i);
                    }
                }

                listall = listnum.Concat(listpart).ToList();

                for (int i = dgvrc - 1; i >= 0; i--)
                {
                    var x = listall.Contains(i);

                    if (dgvpart.Rows[i].Cells[0].Value != null)
                    {
                        if (x == false)
                        {
                            dgvpart.Rows.RemoveAt(i);
                        }
                    }
                }
                #endregion

                #region AssemblyNumFill
                int dgvrc1 = dgvassembly.Rows.Count;
                List<int> listnum1 = new List<int>();
                List<int> listpart1 = new List<int>();
                List<int> listall1 = new List<int>();
                for (int i = 0; i < dgvrc1 - 1; i++)
                {
                    string cellv11 = dgvassembly.Rows[i].Cells[0].Value.ToString();
                    if (cellv11.Contains("Assembly"))
                    {
                        listnum1.Add(i - 1);
                        listpart1.Add(i);
                    }
                }

                listall1 = listnum1.Concat(listpart1).ToList();

                for (int i = dgvrc1 - 1; i >= 0; i--)
                {
                    var x = listall1.Contains(i);

                    if (dgvassembly.Rows[i].Cells[0].Value != null)
                    {
                        if (x == false)
                        {
                            dgvassembly.Rows.RemoveAt(i);
                        }
                    }
                }
                #endregion
            }
            #endregion

            #region DrawingHistory
            if (selectind == 1)
            {
                #region main
                foreach (var ModelObject in new TSMUI.ModelObjectSelector().GetSelectedObjects())
                {
                    Part part1 = ModelObject as Part;
                    string partpos = "";
                    string partprefix = "";
                    bool ppos = part1.GetReportProperty("PART_POS", ref partpos);
                    bool ppref = part1.GetReportProperty("PART_PREFIX", ref partprefix);
                    int lpos = partpos.Length;
                    int lpref = partprefix.Length;
                    string plogpos = "[" + partprefix + "." + partpos.Substring(lpref + 1, lpos - lpref - 1) + "]";
                    Assembly assembly1 = part1.GetAssembly();
                    string assemblypos = "";
                    string assemblyprefix = "";
                    bool amark = assembly1.GetReportProperty("ASSEMBLY_POS", ref assemblypos);
                    bool apref = assembly1.GetReportProperty("ASSEMBLY_PREFIX", ref assemblyprefix);
                    int lapos = assemblypos.Length;
                    int lapref = assemblyprefix.Length;
                    string alogpos = "[" + assemblyprefix + "." + assemblypos.Substring(lapref + 1, lapos - lapref - 1) + "]";

                    if (File.Exists(filepath2) == true)
                    {
                        StreamReader reader = new StreamReader(filepath2, Encoding.GetEncoding(encodetxt));
                        using (reader)
                        {
                            int linenum = 0;
                            string line = reader.ReadLine();
                            while (line != null)
                            {
                                linenum++;
                                if (line.ToString().Contains(plogpos))
                                {
                                    partinfo = line.ToString();
                                    object[] rowdata1 = new object[] { partinfo };
                                    dgvpart.Rows.Add(rowdata1);
                                }
                                if (line.ToString().Contains(alogpos))
                                {
                                    ainfo = line.ToString();
                                    object[] rowdata2 = new object[] { ainfo };
                                    dgvassembly.Rows.Add(rowdata2);
                                }
                                line = reader.ReadLine();
                            }
                        }
                    }
                }
                #endregion
            }
            #endregion
        }

        private void numdwghist_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (numdwghist.SelectedIndex == 0)
            {
                parthist.Text = "Part numbering history";
                assemblyhist.Text = "Assembly numbering history";
            }
            if (numdwghist.SelectedIndex == 1)
            {
                parthist.Text = "Part drawing history";
                assemblyhist.Text = "Assembly drawing history";
            }
        }
    }
}